unit fMyBase;

interface

uses
  QDialogs, QTypes, QActnList, QImgList, QGrids, QDBGrids, QStdCtrls, QForms,
  FMTBcd, SqlExpr, QMenus, Provider, DB, Classes, DBClient, QDBCtrls,
  QControls, QExtCtrls, SysUtils, DBXpress;

type
  TForm1 = class(TForm)
    ImageList1: TImageList;
    ClientDataSet1: TClientDataSet;
    ActionList1: TActionList;
    actFileOpen: TAction;
    actFileExit: TAction;
    actListAll: TAction;
    actFileSave: TAction;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    Exit1: TMenuItem;
    Panel1: TPanel;
    Label2: TLabel;
    cbBinary: TCheckBox;
    Label1: TLabel;
    cbXML: TCheckBox;
    lbFiles: TListBox;
    Splitter1: TSplitter;
    Panel2: TPanel;
    DBNavigator1: TDBNavigator;
    DataSource1: TDataSource;
    Label3: TLabel;
    ePath: TEdit;
    Button1: TButton;
    DataSetProvider1: TDataSetProvider;
    DBGrid1: TDBGrid;
    All1: TMenuItem;
    PopupMenu1: TPopupMenu;
    Open2: TMenuItem;
    Save2: TMenuItem;
    All2: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    SQLTable1: TSQLTable;
    SQLConnection1: TSQLConnection;
    procedure actFileSaveUpdate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure actFileOpenExecute(Sender: TObject);
    procedure actFileSaveExecute(Sender: TObject);
    procedure actListAllExecute(Sender: TObject);
    procedure actFileExitExecute(Sender: TObject);
    procedure actListAllUpdate(Sender: TObject);
  private
    { Private declarations }
    procedure SelectTable(AFileName: string);
    procedure SaveAsMyBase(AFileName: string);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses fSelConnect;

{$R *.xfm}

procedure TForm1.actFileSaveUpdate(Sender: TObject);
begin
  actFileSave.Enabled := DirectoryExists( ePath.Text ) and
    (lbFiles.SelCount > 0);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  Path : string;
begin
  Path := ePath.Text;
  if SelectDirectory( 'Select output directory', '', Path ) then
    ePath.Text := Path;
end;

procedure TForm1.actFileOpenExecute(Sender: TObject);
begin
  if (SelectConnectionForm.ShowModal = mrOk) and
     (SelectConnectionForm.Listbox1.ItemIndex <> -1) then
  begin
    SQLConnection1.ConnectionName := SelectConnectionForm.ListBox1.Items[SelectConnectionForm.Listbox1.ItemIndex];
    SQLConnection1.GetTableNames(lbFiles.Items);
  end;
end;

procedure TForm1.SelectTable(AFileName: string);
begin
  ClientDataSet1.Active := False;
  SQLTable1.TableName := AFileName;
  ClientDataset1.Active := True;
end;

procedure TForm1.actFileSaveExecute(Sender: TObject);
var
  i: integer;
begin
  SQLConnection1.Open;
  for i := 0 to lbFiles.Items.Count -1 do
  begin
    if lbFiles.Selected[i] then
      SaveAsMyBase(lbFiles.Items[i]);
    Refresh;
  end;
  ShowMessage( 'File(s) saved' );
end;

procedure TForm1.SaveAsMyBase(AFileName: string);
  procedure SaveDataset(Ext: string);
  var
    OutFile: string;
  begin
    OutFile := ExtractFileName(AFileName);
    OutFile := ePath.Text + PathSep  + ChangeFileExt(OutFile, '.' + Ext);
    ClientDataSet1.SaveToFile(OutFile);
  end;

begin
  SelectTable(AFileName);
  if cbBinary.Checked then
    SaveDataset('cds');
  if cbXML.Checked then
    SaveDataSet('xml');
end;

procedure TForm1.actListAllExecute(Sender: TObject);
var
  i: integer;
begin
  for i := 0 to lbFiles.Items.Count -1 do
  begin
    lbFiles.Selected[i] := True;
  end;
end;

procedure TForm1.actFileExitExecute(Sender: TObject);
begin
  Close;
end;

procedure TForm1.actListAllUpdate(Sender: TObject);
begin
  actListAll.Enabled := (lbFiles.Items.Count > 0);
end;

end.
